scala.collection.parallel.immutable

# ParHashMap

#### class ParHashMap[K, +V] extends ParMap[K, V] with GenericParMapTemplate[K, V, ParHashMap] with ParMapLike[K, V, ParHashMap[K, V], HashMap[K, V]] with Serializable

Immutable parallel hash map, based on hash tries.

This is a base trait for Scala parallel collections. It defines behaviour common to all parallel collections. Concrete parallel collections should inherit this trait and `ParIterable` if they want to define specific combiner factories.

Parallel operations are implemented with divide and conquer style algorithms that parallelize well. The basic idea is to split the collection into smaller parts until they are small enough to be operated on sequentially.

All of the parallel operations are implemented as tasks within this trait. Tasks rely on the concept of splitters, which extend iterators. Every parallel collection defines:

        def splitter: IterableSplitter[T]

which returns an instance of `IterableSplitter[T]`, which is a subtype of `Splitter[T]`. Parallel iterators have a method `remaining` to check the remaining number of elements, and method `split` which is defined by splitters. Method `split` divides the splitters iterate over into disjunct subsets:

        def split: Seq[Splitter]

which splits the splitter into a sequence of disjunct subsplitters. This is typically a very fast operation which simply creates wrappers around the receiver collection. This can be repeated recursively.

Method `newCombiner` produces a new combiner. Combiners are an extension of builders. They provide a method `combine` which combines two combiners and returns a combiner containing elements of both combiners. This method can be implemented by aggressively copying all the elements into the new combiner or by lazily binding their results. It is recommended to avoid copying all of the elements for performance reasons, although that cost might be negligible depending on the use case. Standard parallel collection combiners avoid copying when merging results, relying either on a two-step lazy construction or specific data-structure properties.

Methods:

        def seq: Sequential
        def par: Repr

produce the sequential or parallel implementation of the collection, respectively. Method `par` just returns a reference to this parallel collection. Method `seq` is efficient - it will not copy the elements. Instead, it will create a sequential version of the collection using the same underlying data structure. Note that this is not the case for sequential collections in general - they may copy the elements and produce a different underlying data structure.

The combination of methods `toMap`, `toSeq` or `toSet` along with `par` and `seq` is a flexible way to change between different collection types.

The method:

        def threshold(sz: Int, p: Int): Int

provides an estimate on the minimum number of elements the collection has before the splitting stops and depends on the number of elements in the collection. A rule of the thumb is the number of elements divided by 8 times the parallelism level. This method may be overridden in concrete implementations if necessary.

Since this trait extends the `Iterable` trait, methods like `size` must also be implemented in concrete collections, while `iterator` forwards to `splitter` by default.

Each parallel collection is bound to a specific fork/join pool, on which dormant worker threads are kept. The fork/join pool contains other information such as the parallelism level, that is, the number of processors used. When a collection is created, it is assigned the default fork/join pool found in the `scala.parallel` package object.

Parallel collections are not necessarily ordered in terms of the `foreach` operation (see `Traversable`). Parallel sequences have a well defined order for iterators - creating an iterator and traversing the elements linearly will always yield the same order. However, bulk operations such as `foreach`, `map` or `filter` always occur in undefined orders for all parallel collections.

Existing parallel collection implementations provide strict parallel iterators. Strict parallel iterators are aware of the number of elements they have yet to traverse. It's also possible to provide non-strict parallel iterators, which do not know the number of elements remaining. To do this, the new collection implementation must override `isStrictSplitterCollection` to `false`. This will make some operations unavailable.

To create a new parallel collection, extend the `ParIterable` trait, and implement `size`, `parallelIterator`, `newCombiner` and `seq`. Having an implicit combiner factory requires extending this trait in addition, as well as providing a companion object, as with regular collections.

Method `size` is implemented as a constant time operation for parallel collections, and parallel collection operations rely on this assumption.

The higher-order functions passed to certain operations may contain side-effects. Since implementations of bulk operations may not be sequential, this means that side-effects may not be predictable and may produce data-races, deadlocks or invalidation of state if care is not taken. It is up to the programmer to either avoid using side-effects or to use some form of synchronization when accessing mutable data.

K

  the key type of the map

V

  the value type of the map

Self Type
  ParHashMap[K, V]
Annotations
  @SerialVersionUID( uid = 1L )
Source
  ParHashMap.scala
Since

  2.9

Linear Supertypes
Serializable, Serializable, ParMap[K, V], ParIterable[(K, V)], ParMap[K, V], ParMapLike[K, V, ParHashMap[K, V], HashMap[K, V]], ParIterable[(K, V)], ParIterableLike[(K, V), ParHashMap[K, V], HashMap[K, V]], Parallel, CustomParallelizable[(K, V), ParHashMap[K, V]], GenericParMapTemplate[K, V, ParHashMap], GenericParTemplate[(K, V), ParIterable], HasNewCombiner[(K, V), ParHashMap[K, V]], GenMap[K, V], GenIterable[(K, V)], GenTraversable[(K, V)], GenericTraversableTemplate[(K, V), ParIterable], HasNewBuilder[(K, V), ParIterable[(K, V)]], GenMapLike[K, V, ParHashMap[K, V]], Equals, GenIterableLike[(K, V), ParHashMap[K, V]], GenTraversableLike[(K, V), ParHashMap[K, V]], Parallelizable[(K, V), ParHashMap[K, V]], GenTraversableOnce[(K, V)], AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. ParHashMap
2. Serializable
3. Serializable
4. ParMap
5. ParIterable
6. ParMap
7. ParMapLike
8. ParIterable
9. ParIterableLike
10. Parallel
11. CustomParallelizable
12. GenericParMapTemplate
13. GenericParTemplate
14. HasNewCombiner
15. GenMap
16. GenIterable
17. GenTraversable
18. GenericTraversableTemplate
19. HasNewBuilder
20. GenMapLike
21. Equals
22. GenIterableLike
23. GenTraversableLike
24. Parallelizable
25. GenTraversableOnce
26. AnyRef
27. Any

Visibility

1. Public
2. All

### Instance Constructors

1. #### new ParHashMap()

### Type Members

1. #### trait Accessor[R, Tp] extends StrictSplitterCheckTask[R, Tp]

   Standard accessor task that iterates over the elements of the collection.

2. #### class Aggregate[S] extends Accessor[S, Aggregate[S]]

   Attributes
     protected[this]

3. #### trait BuilderOps[Elem, To] extends AnyRef

4. #### class Collect[S, That] extends Transformer[Combiner[S, That], Collect[S, That]]

   Attributes
     protected[this]

5. #### abstract class Composite[FR, SR, R, First <: ParIterableLike.this.StrictSplitterCheckTask[FR, _], Second <: ParIterableLike.this.StrictSplitterCheckTask[SR, _]] extends NonDivisibleTask[R, Composite[FR, SR, R, First, Second]]

   Attributes
     protected[this]

6. #### class Copy[U >: T, That] extends Transformer[Combiner[U, That], Copy[U, That]]

   Attributes
     protected

7. #### class CopyToArray[U >: T, This >: Repr] extends Accessor[Unit, CopyToArray[U, This]]

   Attributes
     protected[this]

8. #### class Count extends Accessor[Int, Count]

   Attributes
     protected[this]

9. #### class CreateScanTree[U >: T] extends Transformer[ScanTree[U], CreateScanTree[U]]

   Attributes
     protected[this]

10. #### class Drop[U >: T, This >: Repr] extends Transformer[Combiner[U, This], Drop[U, This]]

    Attributes
      protected[this]

11. #### class Exists extends Accessor[Boolean, Exists]

    Attributes
      protected[this]

12. #### class Filter[U >: T, This >: Repr] extends Transformer[Combiner[U, This], Filter[U, This]]

    Attributes
      protected[this]

13. #### class FilterNot[U >: T, This >: Repr] extends Transformer[Combiner[U, This], FilterNot[U, This]]

    Attributes
      protected[this]

14. #### class Find[U >: T] extends Accessor[Option[U], Find[U]]

    Attributes
      protected[this]

15. #### class FlatMap[S, That] extends Transformer[Combiner[S, That], FlatMap[S, That]]

    Attributes
      protected[this]

16. #### class Fold[U >: T] extends Accessor[U, Fold[U]]

    Attributes
      protected[this]

17. #### class Forall extends Accessor[Boolean, Forall]

    Attributes
      protected[this]

18. #### class Foreach[S] extends Accessor[Unit, Foreach[S]]

    Attributes
      protected[this]

19. #### class FromScanTree[U >: T, That] extends StrictSplitterCheckTask[Combiner[U, That], FromScanTree[U, That]]

    Attributes
      protected[this]

20. #### class GroupBy[K, U >: T] extends Transformer[HashMapCombiner[K, U], GroupBy[K, U]]

    Attributes
      protected[this]

21. #### class Map[S, That] extends Transformer[Combiner[S, That], Map[S, That]]

    Attributes
      protected[this]

22. #### class Max[U >: T] extends Accessor[Option[U], Max[U]]

    Attributes
      protected[this]

23. #### class Min[U >: T] extends Accessor[Option[U], Min[U]]

    Attributes
      protected[this]

24. #### trait NonDivisible[R] extends NonDivisibleTask[R, NonDivisible[R]]

    Attributes
      protected[this]

25. #### trait NonDivisibleTask[R, Tp] extends StrictSplitterCheckTask[R, Tp]

    Attributes
      protected[this]

26. #### abstract class ParComposite[FR, SR, R, First <: ParIterableLike.this.StrictSplitterCheckTask[FR, _], Second <: ParIterableLike.this.StrictSplitterCheckTask[SR, _]] extends Composite[FR, SR, R, First, Second]

    Performs two tasks in parallel, and waits for both to finish.

27. #### class ParHashMapIterator extends ParIterator

28. #### trait ParIterator extends IterableSplitter[T]

    Parallel iterators are split iterators that have additional accessor and transformer methods defined in terms of methods `next` and `hasNext`.

29. #### class Partition[U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Combiner[U, This]), Partition[U, This]]

    Attributes
      protected[this]

30. #### class Product[U >: T] extends Accessor[U, Product[U]]

    Attributes
      protected[this]

31. #### class Reduce[U >: T] extends Accessor[Option[U], Reduce[U]]

    Attributes
      protected[this]

32. #### abstract class ResultMapping[R, Tp, R1] extends NonDivisibleTask[R1, ResultMapping[R, Tp, R1]]

    Attributes
      protected[this]

33. #### type SCPI = SignalContextPassingIterator[ParHashMapIterator]

34. #### type SSCTask[R, Tp] = StrictSplitterCheckTask[R, Tp]

    Definition Classes
      ParIterableLike

35. #### case class ScanLeaf[U >: T](pit: IterableSplitter[U], op: (U, U) ⇒ U, from: Int, len: Int, prev: Option[ScanLeaf[U]], acc: U) extends ScanTree[U] with Product with Serializable

    Attributes
      protected[this]

36. #### case class ScanNode[U >: T](left: ScanTree[U], right: ScanTree[U]) extends ScanTree[U] with Product with Serializable

    Attributes
      protected[this]

37. #### trait ScanTree[U >: T] extends AnyRef

    Attributes
      protected[this]

38. #### abstract class SeqComposite[FR, SR, R, First <: ParIterableLike.this.StrictSplitterCheckTask[FR, _], Second <: ParIterableLike.this.StrictSplitterCheckTask[SR, _]] extends Composite[FR, SR, R, First, Second]

    Sequentially performs one task after another.

39. #### trait SignalContextPassingIterator[+IterRepr <: ParIterator] extends ParIterator

    A stackable modification that ensures signal contexts get passed along the iterators.

40. #### trait SignallingOps[PI <: DelegatedSignalling] extends AnyRef

41. #### class Slice[U >: T, This >: Repr] extends Transformer[Combiner[U, This], Slice[U, This]]

    Attributes
      protected[this]

42. #### class Span[U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Combiner[U, This]), Span[U, This]]

    Attributes
      protected[this]

43. #### class SplitAt[U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Combiner[U, This]), SplitAt[U, This]]

    Attributes
      protected[this]

44. #### trait StrictSplitterCheckTask[R, Tp] extends Task[R, Tp]

    Attributes
      protected

45. #### class Sum[U >: T] extends Accessor[U, Sum[U]]

    Attributes
      protected[this]

46. #### class Take[U >: T, This >: Repr] extends Transformer[Combiner[U, This], Take[U, This]]

    Attributes
      protected[this]

47. #### class TakeWhile[U >: T, This >: Repr] extends Transformer[(Combiner[U, This], Boolean), TakeWhile[U, This]]

    Attributes
      protected[this]

48. #### trait TaskOps[R, Tp] extends AnyRef

49. #### class ToParCollection[U >: T, That] extends Transformer[Combiner[U, That], ToParCollection[U, That]]

    Attributes
      protected[this]

50. #### class ToParMap[K, V, That] extends Transformer[Combiner[(K, V), That], ToParMap[K, V, That]]

    Attributes
      protected[this]

51. #### trait Transformer[R, Tp] extends Accessor[R, Tp]

    Attributes
      protected

52. #### class Zip[U >: T, S, That] extends Transformer[Combiner[(U, S), That], Zip[U, S, That]]

    Attributes
      protected[this]

53. #### class ZipAll[U >: T, S, That] extends Transformer[Combiner[(U, S), That], ZipAll[U, S, That]]

    Attributes
      protected[this]

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def +[U >: V](kv: (K, U)): ParHashMap[K, U]

   Definition Classes
     ParHashMap → GenMapLike

5. #### abstract def ++[B](that: GenTraversableOnce[B]): immutable.ParHashMap[B]

   [use case] Returns a new immutable parallel hash map containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new immutable parallel hash map containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the immutable parallel hash map is the most specific superclass encompassing the element types of the two operands (see example).

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new collection of type `That` which contains all elements of this immutable parallel hash map followed by all elements of `that`.

   Definition Classes
     GenTraversableLike

6. #### def ++[U >: (K, V), That](that: GenTraversableOnce[U])(implicit bf: CanBuildFrom[ParHashMap[K, V], U, That]): That

   Returns a new immutable parallel hash map containing the elements from the left hand operand followed by the elements from the right hand operand.

   Returns a new immutable parallel hash map containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the immutable parallel hash map is the most specific superclass encompassing the element types of the two operands (see example).

   Example:

           scala> val a = LinkedList(1)
           a: scala.collection.mutable.LinkedList[Int] = LinkedList(1)

           scala> val b = LinkedList(2)
           b: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

           scala> val c = a ++ b
           c: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

           scala> val d = LinkedList('a')
           d: scala.collection.mutable.LinkedList[Char] = LinkedList(a)

           scala> val e = c ++ d
           e: scala.collection.mutable.LinkedList[AnyVal] = LinkedList(1, 2, a)

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this immutable parallel hash map followed by all elements of `that`.

   Definition Classes
     ParIterableLike → GenTraversableLike

7. #### def -(k: K): ParHashMap[K, V]

   Definition Classes
     ParHashMap → GenMapLike

8. #### def /:[S](z: S)(op: (S, (K, V)) ⇒ S): S

   Applies a binary operator to a start value and all elements of this immutable parallel hash map, going left to right.

   Applies a binary operator to a start value and all elements of this immutable parallel hash map, going left to right.

   Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

   Examples:

   Note that the folding function used to compute b is equivalent to that used to compute c.

            scala> val a = LinkedList(1,2,3,4)
            a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

            scala> val b = (5 /: a)(_+_)
            b: Int = 15

            scala> val c = (5 /: a)((x,y) => x + y)
            c: Int = 15

   Note: will not terminate for infinite-sized collections.

   Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

   z

     the start value.

   op

     the binary operator.

   returns

     the result of inserting `op` between consecutive elements of this immutable parallel hash map, going left to right with the start value `z` on the left:

                     op(...op(op(z, x1), x2), ..., xn)

     where `x1, ..., xn` are the elements of this immutable parallel hash map.

   Definition Classes
     ParIterableLike → GenTraversableOnce

9. #### def /:\[A1 >: (K, V)](z: A1)(op: (A1, A1) ⇒ A1): A1

   A syntactic sugar for out of order folding.

   A syntactic sugar for out of order folding. See `fold`.

   Example:

            scala> val a = LinkedList(1,2,3,4)
            a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

            scala> val b = (a /:\ 5)(_+_)
            b: Int = 15

   Definition Classes
     GenTraversableOnce

10. #### def :\[S](z: S)(op: ((K, V), S) ⇒ S): S

    Applies a binary operator to all elements of this immutable parallel hash map and a start value, going right to left.

    Applies a binary operator to all elements of this immutable parallel hash map and a start value, going right to left.

    Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

             scala> val a = LinkedList(1,2,3,4)
             a: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2, 3, 4)

             scala> val b = (a :\ 5)(_+_)
             b: Int = 15

             scala> val c = (a :\ 5)((x,y) => x + y)
             c: Int = 15

    z

      the start value

    op

      the binary operator

    returns

      the result of inserting `op` between consecutive elements of this immutable parallel hash map, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this immutable parallel hash map.

    Definition Classes
      ParIterableLike → GenTraversableOnce

11. #### final def ==(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

12. #### final def ==(arg0: Any): Boolean

    Test two objects for equality.

    Test two objects for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      Any

13. #### def aggregate[S](z: S)(seqop: (S, (K, V)) ⇒ S, combop: (S, S) ⇒ S): S

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

           pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    S

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation)

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      ParIterableLike → GenTraversableOnce

14. #### def apply(key: K): V

    Definition Classes
      ParMapLike → GenMapLike

15. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

16. #### def bf2seq[S, That](bf: CanBuildFrom[ParHashMap[K, V], S, That]): CanBuildFrom[HashMap[K, V], S, That]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

17. #### implicit def builder2ops[Elem, To](cb: Builder[Elem, To]): BuilderOps[Elem, To]

    Attributes
      protected
    Definition Classes
      ParIterableLike

18. #### def canEqual(other: Any): Boolean

    Definition Classes
      ParIterableLike

19. #### def cbfactory: () ⇒ Combiner[(K, V), ParHashMap[K, V]]

    Attributes
      protected[this]
    Definition Classes
      ParIterableLike

20. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

21. #### abstract def collect[B](pf: PartialFunction[(K, V), B]): immutable.ParHashMap[B]

    [use case] Builds a new collection by applying a partial function to all elements of this immutable parallel hash map on which the function is defined.

    [use case]

    Builds a new collection by applying a partial function to all elements of this immutable parallel hash map on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the immutable parallel hash map.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      GenTraversableLike

22. #### def collect[S, That](pf: PartialFunction[(K, V), S])(implicit bf: CanBuildFrom[ParHashMap[K, V], S, That]): That

    Builds a new collection by applying a partial function to all elements of this immutable parallel hash map on which the function is defined.

    Builds a new collection by applying a partial function to all elements of this immutable parallel hash map on which the function is defined.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    pf

      the partial function which filters and maps the immutable parallel hash map.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike

23. #### def companion: GenericCompanion[ParIterable] with GenericParCompanion[ParIterable]

    The factory companion object that builds instances of class immutable.

    The factory companion object that builds instances of class immutable.ParHashMap. (or its `Iterable` superclass where class immutable.ParHashMap is not a `Seq`.)

    Definition Classes
      ParIterable → ParIterable → GenericParTemplate → GenIterable → GenTraversable → GenericTraversableTemplate

24. #### def copyToArray[U >: (K, V)](xs: Array[U], start: Int, len: Int): Unit

    Definition Classes
      ParIterableLike → GenTraversableOnce

25. #### abstract def copyToArray(xs: Array[(K, V)], start: Int): Unit

    [use case] Copies values of this immutable parallel hash map to an array.

    [use case]

    Copies values of this immutable parallel hash map to an array. Fills the given array `xs` with values of this immutable parallel hash map, beginning at index `start`. Copying will stop once either the end of the current immutable parallel hash map is reached, or the end of the array is reached.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      GenTraversableOnce

26. #### def copyToArray[U >: (K, V)](xs: Array[U], start: Int): Unit

    Copies values of this immutable parallel hash map to an array.

    Copies values of this immutable parallel hash map to an array. Fills the given array `xs` with values of this immutable parallel hash map, beginning at index `start`. Copying will stop once either the end of the current immutable parallel hash map is reached, or the end of the array is reached.

    Note: will not terminate for infinite-sized collections.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      ParIterableLike → GenTraversableOnce

27. #### abstract def copyToArray(xs: Array[(K, V)]): Unit

    [use case] Copies values of this immutable parallel hash map to an array.

    [use case]

    Copies values of this immutable parallel hash map to an array. Fills the given array `xs` with values of this immutable parallel hash map. Copying will stop once either the end of the current immutable parallel hash map is reached, or the end of the array is reached.

    xs

      the array to fill.

    Definition Classes
      GenTraversableOnce

28. #### def copyToArray[U >: (K, V)](xs: Array[U]): Unit

    Copies values of this immutable parallel hash map to an array.

    Copies values of this immutable parallel hash map to an array. Fills the given array `xs` with values of this immutable parallel hash map. Copying will stop once either the end of the current immutable parallel hash map is reached, or the end of the array is reached.

    Note: will not terminate for infinite-sized collections.

    xs

      the array to fill.

    Definition Classes
      ParIterableLike → GenTraversableOnce

29. #### def count(p: ((K, V)) ⇒ Boolean): Int

    Counts the number of elements in the immutable parallel hash map which satisfy a predicate.

    Counts the number of elements in the immutable parallel hash map which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      ParIterableLike → GenTraversableOnce

30. #### def debugBuffer: ArrayBuffer[String]

    Definition Classes
      ParIterableLike

31. #### def default(key: K): V

    Definition Classes
      ParMapLike → GenMapLike

32. #### implicit def delegatedSignalling2ops[PI <: DelegatedSignalling](it: PI): SignallingOps[PI]

    Attributes
      protected
    Definition Classes
      ParIterableLike

33. #### def drop(n: Int): ParHashMap[K, V]

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    n

      the number of elements to drop from this immutable parallel hash map.

    returns

      a immutable parallel hash map consisting of all elements of this immutable parallel hash map except the first `n` ones, or else the empty immutable parallel hash map, if this immutable parallel hash map has less than `n` elements.

    Definition Classes
      ParIterableLike → GenTraversableLike

34. #### def dropWhile(pred: ((K, V)) ⇒ Boolean): ParHashMap[K, V]

    Drops all elements in the longest prefix of elements that satisfy the predicate, and returns a collection composed of the remaining elements.

    Drops all elements in the longest prefix of elements that satisfy the predicate, and returns a collection composed of the remaining elements.

    This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state. The index flag is initially set to maximum integer value.

    pred

      the predicate used to test the elements

    returns

      a collection composed of all the elements after the longest prefix of elements in this immutable parallel hash map that satisfy the predicate `pred`

    Definition Classes
      ParIterableLike → GenTraversableLike

35. #### def empty: ParHashMap[K, V]

    Definition Classes
      ParHashMap → ParMap → ParMap → ParMapLike

36. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

37. #### def equals(that: Any): Boolean

    Compares two maps structurally; i.

    Compares two maps structurally; i.e. checks if all mappings contained in this map are also contained in the other map, and vice versa.

    that

      the other map

    returns

      `true` if both maps contain exactly the same mappings, `false` otherwise.

    Definition Classes
      GenMapLike → Equals → AnyRef → Any

38. #### def exists(pred: ((K, V)) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some element of this immutable parallel hash map.

    Tests whether a predicate holds for some element of this immutable parallel hash map.

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    returns

      true if `p` holds for some element, false otherwise

    Definition Classes
      ParIterableLike → GenTraversableOnce

39. #### def filter(pred: ((K, V)) ⇒ Boolean): ParHashMap[K, V]

    Selects all elements of this immutable parallel hash map which satisfy a predicate.

    Selects all elements of this immutable parallel hash map which satisfy a predicate.

    returns

      a new immutable parallel hash map consisting of all elements of this immutable parallel hash map that satisfy the given predicate `p`. Their order may not be preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike

40. #### def filterNot(pred: ((K, V)) ⇒ Boolean): ParHashMap[K, V]

    Selects all elements of this immutable parallel hash map which do not satisfy a predicate.

    Selects all elements of this immutable parallel hash map which do not satisfy a predicate.

    returns

      a new immutable parallel hash map consisting of all elements of this immutable parallel hash map that do not satisfy the given predicate `p`. Their order may not be preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike

41. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

42. #### def find(pred: ((K, V)) ⇒ Boolean): Option[(K, V)]

    Finds some element in the collection for which the predicate holds, if such an element exists.

    Finds some element in the collection for which the predicate holds, if such an element exists. The element may not necessarily be the first such element in the iteration order.

    If there are multiple elements obeying the predicate, the choice is nondeterministic.

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    returns

      an option value with the element if such an element exists, or `None` otherwise

    Definition Classes
      ParIterableLike → GenTraversableOnce

43. #### abstract def flatMap[B](f: ((K, V)) ⇒ GenTraversableOnce[B]): immutable.ParHashMap[B]

    [use case] Builds a new collection by applying a function to all elements of this immutable parallel hash map and using the elements of the resulting collections.

    [use case]

    Builds a new collection by applying a function to all elements of this immutable parallel hash map and using the elements of the resulting collections. For example:

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this immutable parallel hash map and concatenating the results.

    Definition Classes
      GenTraversableLike

44. #### def flatMap[S, That](f: ((K, V)) ⇒ GenTraversableOnce[S])(implicit bf: CanBuildFrom[ParHashMap[K, V], S, That]): That

    Builds a new collection by applying a function to all elements of this immutable parallel hash map and using the elements of the resulting collections.

    Builds a new collection by applying a function to all elements of this immutable parallel hash map and using the elements of the resulting collections. For example:

         def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of immutable parallel hash map. This might cause unexpected results sometimes. For example:

         // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
         def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

         // lettersOf will return a Set[Char], not a Seq
         def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

         // xs will be a an Iterable[Int]
         val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

         // ys will be a Map[Int, Int]
         val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the given collection-valued function `f` to each element of this immutable parallel hash map and concatenating the results.

    Definition Classes
      ParIterableLike → GenTraversableLike

45. #### abstract def flatten[B]: immutable.ParHashMap[B]

    [use case] Converts this immutable parallel hash map of traversable collections into a immutable parallel hash map formed by the elements of these traversable collections.

    [use case]

    Converts this immutable parallel hash map of traversable collections into a immutable parallel hash map formed by the elements of these traversable collections.

    B

      the type of the elements of each traversable collection.

    returns

      a new immutable parallel hash map resulting from concatenating all element immutable parallel hash maps.

    Definition Classes
      GenericTraversableTemplate

46. #### def flatten[B](implicit asTraversable: ((K, V)) ⇒ TraversableOnce[B]): ParIterable[B]

    Converts this immutable parallel hash map of traversable collections into a immutable parallel hash map formed by the elements of these traversable collections.

    Converts this immutable parallel hash map of traversable collections into a immutable parallel hash map formed by the elements of these traversable collections.

    The resulting collection's type will be guided by the static type of immutable parallel hash map. For example:

         val xs = List(Set(1, 2, 3), Set(1, 2, 3))
         // xs == List(1, 2, 3, 1, 2, 3)

         val ys = Set(List(1, 2, 3), List(3, 2, 1))
         // ys == Set(1, 2, 3)

    B

      the type of the elements of each traversable collection.

    asTraversable

      an implicit conversion which asserts that the element type of this immutable parallel hash map is a `Traversable`.

    returns

      a new immutable parallel hash map resulting from concatenating all element immutable parallel hash maps.

    Definition Classes
      GenericTraversableTemplate

47. #### def fold[U >: (K, V)](z: U)(op: (U, U) ⇒ U): U

    Folds the elements of this sequence using the specified associative binary operator.

    Folds the elements of this sequence using the specified associative binary operator. The order in which the elements are reduced is unspecified and may be nondeterministic.

    Note this method has a different signature than the `foldLeft` and `foldRight` methods of the trait `Traversable`. The result of folding may only be a supertype of this parallel collection's type parameter `T`.

    U

      a type parameter for the binary operator, a supertype of `T`.

    z

      a neutral element for the fold operation, it may be added to the result an arbitrary number of times, not changing the result (e.g. `Nil` for list concatenation, 0 for addition, or 1 for multiplication)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      ParIterableLike → GenTraversableOnce

48. #### def foldLeft[S](z: S)(op: (S, (K, V)) ⇒ S): S

    Applies a binary operator to a start value and all elements of this immutable parallel hash map, going left to right.

    Applies a binary operator to a start value and all elements of this immutable parallel hash map, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this immutable parallel hash map, going left to right with the start value `z` on the left:

                      op(...op(z, x1), x2, ..., xn)

      where `x1, ..., xn` are the elements of this immutable parallel hash map.

    Definition Classes
      ParIterableLike → GenTraversableOnce

49. #### def foldRight[S](z: S)(op: ((K, V), S) ⇒ S): S

    Applies a binary operator to all elements of this immutable parallel hash map and a start value, going right to left.

    Applies a binary operator to all elements of this immutable parallel hash map and a start value, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this immutable parallel hash map, going right to left with the start value `z` on the right:

                      op(x1, op(x2, ... op(xn, z)...))

      where `x1, ..., xn` are the elements of this immutable parallel hash map.

    Definition Classes
      ParIterableLike → GenTraversableOnce

50. #### def forall(pred: ((K, V)) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this immutable parallel hash map.

    Tests whether a predicate holds for all elements of this immutable parallel hash map.

    This method will use `abort` signalling capabilities. This means that splitters may send and read `abort` signals.

    returns

      true if `p` holds for all elements, false otherwise

    Definition Classes
      ParIterableLike → GenTraversableOnce

51. #### def foreach[U](f: ((K, V)) ⇒ U): Unit

    Applies a function `f` to all the elements of immutable parallel hash map in a sequential order.

    Applies a function `f` to all the elements of immutable parallel hash map in a sequential order.

    U

      the result type of the function applied to each element, which is always discarded

    f

      function applied to each element

    Definition Classes
      ParIterableLike → GenTraversableLike → GenTraversableOnce

52. #### def genericBuilder[B]: Combiner[B, ParIterable[B]]

    The generic builder that builds instances of immutable.

    The generic builder that builds instances of immutable.ParHashMap at arbitrary element types.

    Definition Classes
      GenericParTemplate → GenericTraversableTemplate

53. #### def genericCombiner[B]: Combiner[B, ParIterable[B]]

    Definition Classes
      GenericParTemplate

54. #### def genericMapCombiner[P, Q]: Combiner[(P, Q), ParHashMap[P, Q]]

    Definition Classes
      GenericParMapTemplate

55. #### def get(k: K): Option[V]

    Definition Classes
      ParHashMap → GenMapLike

56. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

57. #### def groupBy[K](f: ((K, V)) ⇒ K): ParMap[K, ParHashMap[K, V]]

    Partitions this immutable parallel hash map into a map of immutable parallel hash maps according to some discriminator function.

    Partitions this immutable parallel hash map into a map of immutable parallel hash maps according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new immutable parallel hash map.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to immutable parallel hash maps such that the following invariant holds:

                          (xs partition f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a immutable parallel hash map of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      ParIterableLike → GenTraversableLike

58. #### def hasDefiniteSize: Boolean

    Definition Classes
      ParIterableLike → GenTraversableOnce

59. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      GenMapLike → AnyRef → Any

60. #### def head: (K, V)

    Definition Classes
      GenIterableLike → GenTraversableLike

61. #### def isEmpty: Boolean

    Tests whether the immutable parallel hash map is empty.

    Tests whether the immutable parallel hash map is empty.

    returns

      `true` if the immutable parallel hash map contains no elements, `false` otherwise.

    Definition Classes
      GenIterableLike → GenTraversableOnce

62. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

63. #### def isStrictSplitterCollection: Boolean

    Denotes whether this parallel collection has strict splitters.

    Denotes whether this parallel collection has strict splitters.

    This is true in general, and specific collection instances may choose to override this method. Such collections will fail to execute methods which rely on splitters being strict, i.e. returning a correct value in the `remaining` method.

    This method helps ensure that such failures occur on method invocations, rather than later on and in unpredictable ways.

    Definition Classes
      ParIterableLike

64. #### final def isTraversableAgain: Boolean

    Tests whether this immutable parallel hash map can be repeatedly traversed.

    Tests whether this immutable parallel hash map can be repeatedly traversed.

    returns

      `true`

    Definition Classes
      GenTraversableLike → GenTraversableOnce

65. #### def iterator: Splitter[(K, V)]

    Creates a new split iterator used to traverse the elements of this collection.

    Creates a new split iterator used to traverse the elements of this collection.

    By default, this method is implemented in terms of the protected `splitter` method.

    returns

      a split iterator

    Definition Classes
      ParIterableLike → GenIterableLike

66. #### abstract def map[B](f: ((K, V)) ⇒ B): immutable.ParHashMap[B]

    [use case] Builds a new collection by applying a function to all elements of this immutable parallel hash map.

    [use case]

    Builds a new collection by applying a function to all elements of this immutable parallel hash map.

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new collection of type `That` resulting from applying the given function `f` to each element of this immutable parallel hash map and collecting the results.

    Definition Classes
      GenTraversableLike

67. #### def map[S, That](f: ((K, V)) ⇒ S)(implicit bf: CanBuildFrom[ParHashMap[K, V], S, That]): That

    Builds a new collection by applying a function to all elements of this immutable parallel hash map.

    Builds a new collection by applying a function to all elements of this immutable parallel hash map.

    That

      the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

    f

      the function to apply to each element.

    bf

      an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

    returns

      a new collection of type `That` resulting from applying the given function `f` to each element of this immutable parallel hash map and collecting the results.

    Definition Classes
      ParIterableLike → GenTraversableLike

68. #### def mapCompanion: GenericParMapCompanion[ParHashMap]

    Definition Classes
      ParHashMap → ParMap → ParMap → GenericParMapTemplate

69. #### abstract def max: (K, V)

    [use case] Finds the largest element.

    [use case]

    Finds the largest element.

    returns

      the largest element of this immutable parallel hash map with respect to the ordering `cmp`.

    Definition Classes
      GenTraversableOnce

70. #### def max[U >: (K, V)](implicit ord: Ordering[U]): (K, V)

    Finds the largest element.

    Finds the largest element.

    returns

      the largest element of this immutable parallel hash map with respect to the ordering `cmp`.

    Definition Classes
      ParIterableLike → GenTraversableOnce

71. #### def maxBy[S](f: ((K, V)) ⇒ S)(implicit cmp: Ordering[S]): (K, V)

    Definition Classes
      ParIterableLike → GenTraversableOnce

72. #### abstract def min: (K, V)

    [use case] Finds the smallest element.

    [use case]

    Finds the smallest element.

    returns

      the smallest element of this immutable parallel hash map with respect to the ordering `cmp`.

    Definition Classes
      GenTraversableOnce

73. #### def min[U >: (K, V)](implicit ord: Ordering[U]): (K, V)

    Finds the smallest element.

    Finds the smallest element.

    returns

      the smallest element of this immutable parallel hash map with respect to the ordering `cmp`.

    Definition Classes
      ParIterableLike → GenTraversableOnce

74. #### def minBy[S](f: ((K, V)) ⇒ S)(implicit cmp: Ordering[S]): (K, V)

    Definition Classes
      ParIterableLike → GenTraversableOnce

75. #### def mkString: String

    Displays all elements of this immutable parallel hash map in a string.

    Displays all elements of this immutable parallel hash map in a string.

    returns

      a string representation of this immutable parallel hash map. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this immutable parallel hash map follow each other without any separator string.

    Definition Classes
      ParIterableLike → GenTraversableOnce

76. #### def mkString(sep: String): String

    Displays all elements of this immutable parallel hash map in a string using a separator string.

    Displays all elements of this immutable parallel hash map in a string using a separator string.

    sep

      the separator string.

    returns

      a string representation of this immutable parallel hash map. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this immutable parallel hash map are separated by the string `sep`.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("|") = "1|2|3"`

77. #### def mkString(start: String, sep: String, end: String): String

    Displays all elements of this immutable parallel hash map in a string using start, end, and separator strings.

    Displays all elements of this immutable parallel hash map in a string using start, end, and separator strings.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      a string representation of this immutable parallel hash map. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this immutable parallel hash map are separated by the string `sep`.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

78. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

79. #### def newBuilder: Builder[(K, V), ParIterable[(K, V)]]

    The builder that builds instances of type immutable.

    The builder that builds instances of type immutable.ParHashMap[A]

    Attributes
      protected[this]
    Definition Classes
      GenericParTemplate → GenericTraversableTemplate → HasNewBuilder

80. #### def newCombiner: HashMapCombiner[K, V]

    Attributes
      protected[this]
    Definition Classes
      ParHashMap → GenericParMapTemplate → GenericParTemplate → HasNewCombiner

81. #### def nonEmpty: Boolean

    Tests whether the immutable parallel hash map is not empty.

    Tests whether the immutable parallel hash map is not empty.

    returns

      `true` if the immutable parallel hash map contains at least one element, `false` otherwise.

    Definition Classes
      ParIterableLike → GenTraversableOnce

82. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

83. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

84. #### def par: ParHashMap[K, V]

    Returns a parallel implementation of this collection.

    Returns a parallel implementation of this collection.

    For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

    Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

    All parallel collections return a reference to themselves.

    returns

      a parallel implementation of this collection

    Definition Classes
      ParIterableLike → CustomParallelizable → Parallelizable

85. #### def parCombiner: Combiner[(K, V), ParHashMap[K, V]]

    The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

    The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

    returns

      a combiner for the parallel collection of type `ParRepr`

    Attributes
      protected[this]
    Definition Classes
      CustomParallelizable → Parallelizable

86. #### def partition(pred: ((K, V)) ⇒ Boolean): (ParHashMap[K, V], ParHashMap[K, V])

    Partitions this immutable parallel hash map in two immutable parallel hash maps according to a predicate.

    Partitions this immutable parallel hash map in two immutable parallel hash maps according to a predicate.

    returns

      a pair of immutable parallel hash maps: the first immutable parallel hash map consists of all elements that satisfy the predicate `p` and the second immutable parallel hash map consists of all elements that don't. The relative order of the elements in the resulting immutable parallel hash maps may not be preserved.

    Definition Classes
      ParIterableLike → GenTraversableLike

87. #### abstract def product: (K, V)

    [use case] Multiplies up the elements of this collection.

    [use case]

    Multiplies up the elements of this collection.

    returns

      the product of all elements of this immutable parallel hash map with respect to the `*` operator in `num`.

    Definition Classes
      GenTraversableOnce

88. #### def product[U >: (K, V)](implicit num: Numeric[U]): U

    Multiplies up the elements of this collection.

    Multiplies up the elements of this collection.

    num

      an implicit parameter defining a set of numeric operations which includes the `*` operator to be used in forming the product.

    returns

      the product of all elements of this immutable parallel hash map with respect to the `*` operator in `num`.

    Definition Classes
      ParIterableLike → GenTraversableOnce

89. #### def reduce[U >: (K, V)](op: (U, U) ⇒ U): U

    Reduces the elements of this sequence using the specified associative binary operator.

    Reduces the elements of this sequence using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    Note this method has a different signature than the `reduceLeft` and `reduceRight` methods of the trait `Traversable`. The result of reducing may only be a supertype of this parallel collection's type parameter `T`.

    U

      A type parameter for the binary operator, a supertype of `T`.

    op

      A binary operator that must be associative.

    returns

      The result of applying reduce operator `op` between all the elements if the collection is nonempty.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Exceptions thrown
      UnsupportedOperationException

      if this immutable parallel hash map is empty.

90. #### def reduceLeft[U >: (K, V)](op: (U, (K, V)) ⇒ U): U

    Definition Classes
      ParIterableLike

91. #### def reduceLeftOption[U >: (K, V)](op: (U, (K, V)) ⇒ U): Option[U]

    Optionally applies a binary operator to all elements of this immutable parallel hash map, going left to right.

    Optionally applies a binary operator to all elements of this immutable parallel hash map, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceLeft(op)` is this immutable parallel hash map is nonempty, `None` otherwise.

    Definition Classes
      ParIterableLike → GenTraversableOnce

92. #### def reduceOption[U >: (K, V)](op: (U, U) ⇒ U): Option[U]

    Optionally reduces the elements of this sequence using the specified associative binary operator.

    Optionally reduces the elements of this sequence using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    Note this method has a different signature than the `reduceLeftOption` and `reduceRightOption` methods of the trait `Traversable`. The result of reducing may only be a supertype of this parallel collection's type parameter `T`.

    U

      A type parameter for the binary operator, a supertype of `T`.

    op

      A binary operator that must be associative.

    returns

      An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

    Definition Classes
      ParIterableLike → GenTraversableOnce

93. #### def reduceRight[U >: (K, V)](op: ((K, V), U) ⇒ U): U

    Applies a binary operator to all elements of this immutable parallel hash map, going right to left.

    Applies a binary operator to all elements of this immutable parallel hash map, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this immutable parallel hash map, going right to left:

                      op(x,,1,,, op(x,,2,,, ..., op(x,,n-1,,, x,,n,,)...))

      where `x1, ..., xn` are the elements of this immutable parallel hash map.

    Definition Classes
      ParIterableLike → GenTraversableOnce
    Exceptions thrown
      `UnsupportedOperationException`

      if this immutable parallel hash map is empty.

94. #### def reduceRightOption[U >: (K, V)](op: ((K, V), U) ⇒ U): Option[U]

    Optionally applies a binary operator to all elements of this immutable parallel hash map, going right to left.

    Optionally applies a binary operator to all elements of this immutable parallel hash map, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    op

      the binary operator.

    returns

      an option value containing the result of `reduceRight(op)` is this immutable parallel hash map is nonempty, `None` otherwise.

    Definition Classes
      ParIterableLike → GenTraversableOnce

95. #### def repr: ParHashMap[K, V]

    Definition Classes
      ParIterableLike → GenTraversableLike

96. #### def reuse[S, That](oldc: Option[Combiner[S, That]], newc: Combiner[S, That]): Combiner[S, That]

    Optionally reuses an existing combiner for better performance.

    Optionally reuses an existing combiner for better performance. By default it doesn't - subclasses may override this behaviour. The provided combiner `oldc` that can potentially be reused will be either some combiner from the previous computational task, or `None` if there was no previous phase (in which case this method must return `newc`).

    oldc

      The combiner that is the result of the previous task, or `None` if there was no previous task.

    newc

      The new, empty combiner that can be used.

    returns

      Either `newc` or `oldc`.

    Attributes
      protected
    Definition Classes
      ParHashMap → ParIterableLike

97. #### abstract def sameElements(that: GenIterable[(K, V)]): Boolean

    [use case] Checks if the other iterable collection contains the same elements in the same order as this immutable parallel hash map.

    [use case]

    Checks if the other iterable collection contains the same elements in the same order as this immutable parallel hash map.

    that

      the collection to compare with.

    returns

      `true`, if both collections contain the same elements in the same order, `false` otherwise.

    Definition Classes
      GenIterableLike

98. #### def sameElements[U >: (K, V)](that: GenIterable[U]): Boolean

    Checks if the other iterable collection contains the same elements in the same order as this immutable parallel hash map.

    Checks if the other iterable collection contains the same elements in the same order as this immutable parallel hash map.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    Note: will not terminate for infinite-sized collections.

    that

      the collection to compare with.

    returns

      `true`, if both collections contain the same elements in the same order, `false` otherwise.

    Definition Classes
      ParIterableLike → GenIterableLike

99. #### abstract def scan(z: (K, V))(op: ((K, V), (K, V)) ⇒ (K, V)): immutable.ParHashMap[(K, V)]

    [use case] Computes a prefix scan of the elements of the collection.

    [use case]

    Computes a prefix scan of the elements of the collection.

    z

      neutral element for the operator `op`

    op

      the associative operator for the scan

    returns

      a collection containing the prefix scan of the elements in the original collection

    Definition Classes
      ParIterableLike

100. #### def scan[U >: (K, V), That](z: U)(op: (U, U) ⇒ U)(implicit bf: CanBuildFrom[ParHashMap[K, V], U, That]): That

     Computes a prefix scan of the elements of the collection.

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     U

       element type of the resulting collection

     That

       type of the resulting collection

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     returns

       a collection containing the prefix scan of the elements in the original collection

     Definition Classes
       ParIterableLike → GenTraversableLike

101. #### def scanBlockSize: Int

     Attributes
       protected[this]
     Definition Classes
       ParIterableLike

102. #### def scanLeft[S, That](z: S)(op: (S, (K, V)) ⇒ S)(implicit bf: CanBuildFrom[ParHashMap[K, V], S, That]): That

     Produces a collection containing cummulative results of applying the operator going left to right.

     Produces a collection containing cummulative results of applying the operator going left to right.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       ParIterableLike → GenTraversableLike

103. #### def scanRight[S, That](z: S)(op: ((K, V), S) ⇒ S)(implicit bf: CanBuildFrom[ParHashMap[K, V], S, That]): That

     Produces a collection containing cummulative results of applying the operator going right to left.

     Produces a collection containing cummulative results of applying the operator going right to left. The head of the collection is the last cummulative result.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     Example:

            List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       ParIterableLike → GenTraversableLike

104. #### def seq: HashMap[K, V]

     Definition Classes
       ParHashMap → ParIterableLike → GenMap → GenIterable → GenTraversable → GenMapLike → Parallelizable → GenTraversableOnce

105. #### def sequentially[S, That <: Parallel](b: (HashMap[K, V]) ⇒ Parallelizable[S, That]): ParHashMap[K, V]

     Attributes
       protected[this]
     Definition Classes
       ParIterableLike

106. #### def size: Int

     The size of this immutable parallel hash map.

     The size of this immutable parallel hash map.

     Note: will not terminate for infinite-sized collections.

     returns

       the number of elements in this immutable parallel hash map.

     Definition Classes
       ParHashMap → GenTraversableLike → GenTraversableOnce

107. #### def slice(unc_from: Int, unc_until: Int): ParHashMap[K, V]

     Selects an interval of elements.

     Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

            from <= indexOf(x) < until

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       a immutable parallel hash map containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this immutable parallel hash map.

     Definition Classes
       ParIterableLike → GenTraversableLike

108. #### def span(pred: ((K, V)) ⇒ Boolean): (ParHashMap[K, V], ParHashMap[K, V])

     Splits this immutable parallel hash map into a prefix/suffix pair according to a predicate.

     Splits this immutable parallel hash map into a prefix/suffix pair according to a predicate.

     This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state. The index flag is initially set to maximum integer value.

     pred

       the predicate used to test the elements

     returns

       a pair consisting of the longest prefix of the collection for which all the elements satisfy `pred`, and the rest of the collection

     Definition Classes
       ParIterableLike → GenTraversableLike

109. #### def splitAt(n: Int): (ParHashMap[K, V], ParHashMap[K, V])

     Splits this immutable parallel hash map into two at a given position.

     Splits this immutable parallel hash map into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       the position at which to split.

     returns

       a pair of immutable parallel hash maps consisting of the first `n` elements of this immutable parallel hash map, and the other elements.

     Definition Classes
       ParIterableLike → GenTraversableLike

110. #### def splitter: IterableSplitter[(K, V)]

     Creates a new parallel iterator used to traverse the elements of this parallel collection.

     Creates a new parallel iterator used to traverse the elements of this parallel collection. This iterator is more specific than the iterator of the returned by `iterator`, and augmented with additional accessor and transformer methods.

     returns

       a parallel iterator

     Definition Classes
       ParHashMap → ParIterableLike

111. #### def stringPrefix: String

     Defines the prefix of this object's `toString` representation.

     Defines the prefix of this object's `toString` representation.

     returns

       a string representation which starts the result of `toString` applied to this immutable parallel hash map. By default the string prefix is the simple name of the collection class immutable parallel hash map.

     Definition Classes
       ParMap → ParMap → ParIterable → GenTraversableLike

112. #### abstract def sum: (K, V)

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements of this immutable parallel hash map with respect to the `+` operator in `num`.

     Definition Classes
       GenTraversableOnce

113. #### def sum[U >: (K, V)](implicit num: Numeric[U]): U

     Sums up the elements of this collection.

     Sums up the elements of this collection.

     num

       an implicit parameter defining a set of numeric operations which includes the `+` operator to be used in forming the sum.

     returns

       the sum of all elements of this immutable parallel hash map with respect to the `+` operator in `num`.

     Definition Classes
       ParIterableLike → GenTraversableOnce

114. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

115. #### def tail: ParHashMap[K, V]

     Selects all elements except the first.

     Selects all elements except the first.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     returns

       a immutable parallel hash map consisting of all elements of this immutable parallel hash map except the first one.

     Definition Classes
       GenTraversableLike
     Exceptions thrown
       `UnsupportedOperationException`

       if the immutable parallel hash map is empty.

116. #### def take(n: Int): ParHashMap[K, V]

     Selects first n elements.

     Selects first n elements.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     n

       Tt number of elements to take from this immutable parallel hash map.

     returns

       a immutable parallel hash map consisting only of the first `n` elements of this immutable parallel hash map, or else the whole immutable parallel hash map, if it has less than `n` elements.

     Definition Classes
       ParIterableLike → GenTraversableLike

117. #### def takeWhile(pred: ((K, V)) ⇒ Boolean): ParHashMap[K, V]

     Takes the longest prefix of elements that satisfy the predicate.

     Takes the longest prefix of elements that satisfy the predicate.

     This method will use `indexFlag` signalling capabilities. This means that splitters may set and read the `indexFlag` state. The index flag is initially set to maximum integer value.

     pred

       the predicate used to test the elements

     returns

       the longest prefix of this immutable parallel hash map of elements that satisy the predicate `pred`

     Definition Classes
       ParIterableLike → GenTraversableLike

118. #### implicit def task2ops[R, Tp](tsk: SSCTask[R, Tp]): TaskOps[R, Tp]

     Attributes
       protected
     Definition Classes
       ParIterableLike

119. #### def threshold(sz: Int, p: Int): Int

     Some minimal number of elements after which this collection should be handled sequentially by different processors.

     Some minimal number of elements after which this collection should be handled sequentially by different processors.

     This method depends on the size of the collection and the parallelism level, which are both specified as arguments.

     sz

       the size based on which to compute the threshold

     p

       the parallelism level based on which to compute the threshold

     returns

       the maximum number of elements for performing operations sequentially

     Definition Classes
       ParIterableLike

120. #### abstract def toArray: Array[(K, V)]

     [use case] Converts this immutable parallel hash map to an array.

     [use case]

     Converts this immutable parallel hash map to an array.

     Note: will not terminate for infinite-sized collections.

     returns

       an array containing all elements of this immutable parallel hash map.

     Definition Classes
       GenTraversableOnce

121. #### def toArray[U >: (K, V)](implicit arg0: ClassManifest[U]): Array[U]

     Converts this immutable parallel hash map to an array.

     Converts this immutable parallel hash map to an array.

     Note: will not terminate for infinite-sized collections.

     returns

       an array containing all elements of this immutable parallel hash map.

     Definition Classes
       ParIterableLike → GenTraversableOnce

122. #### def toBuffer[U >: (K, V)]: Buffer[U]

     Converts this immutable parallel hash map to a mutable buffer.

     Converts this immutable parallel hash map to a mutable buffer.

     Note: will not terminate for infinite-sized collections.

     returns

       a buffer containing all elements of this immutable parallel hash map.

     Definition Classes
       ParIterableLike → GenTraversableOnce

123. #### def toIndexedSeq[U >: (K, V)]: IndexedSeq[U]

     Converts this immutable parallel hash map to an indexed sequence.

     Converts this immutable parallel hash map to an indexed sequence.

     Note: will not terminate for infinite-sized collections.

     returns

       an indexed sequence containing all elements of this immutable parallel hash map.

     Definition Classes
       ParIterableLike → GenTraversableOnce

124. #### def toIterable: ParIterable[(K, V)]

     Converts this immutable parallel hash map to an iterable collection.

     Converts this immutable parallel hash map to an iterable collection. Note that the choice of target `Iterable` is lazy in this default implementation as this `TraversableOnce` may be lazy and unevaluated (i.e. it may be an iterator which is only traversable once).

     Note: will not terminate for infinite-sized collections.

     returns

       an `Iterable` containing all elements of this immutable parallel hash map.

     Definition Classes
       ParIterable → ParIterableLike → GenTraversableOnce

125. #### def toIterator: Iterator[(K, V)]

     Returns an Iterator over the elements in this immutable parallel hash map.

     Returns an Iterator over the elements in this immutable parallel hash map. Will return the same Iterator if this instance is already an Iterator.

     Note: will not terminate for infinite-sized collections.

     returns

       an Iterator containing all elements of this immutable parallel hash map.

     Definition Classes
       ParIterableLike → GenTraversableOnce

126. #### def toList: List[(K, V)]

     Converts this immutable parallel hash map to a list.

     Converts this immutable parallel hash map to a list.

     Note: will not terminate for infinite-sized collections.

     returns

       a list containing all elements of this immutable parallel hash map.

     Definition Classes
       ParIterableLike → GenTraversableOnce

127. #### abstract def toMap[T, U]: Map[T, U]

     [use case] Converts this immutable parallel hash map to a map.

     [use case]

     Converts this immutable parallel hash map to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     Note: will not terminate for infinite-sized collections.

     returns

       a map containing all elements of this immutable parallel hash map.

     Definition Classes
       GenTraversableOnce

128. #### def toMap[P, Q](implicit ev: <:<[(K, V), (P, Q)]): ParMap[P, Q]

     Converts this immutable parallel hash map to a map.

     Converts this immutable parallel hash map to a map. This method is unavailable unless the elements are members of Tuple2, each ((T, U)) becoming a key-value pair in the map. Duplicate keys will be overwritten by later keys: if this is an unordered collection, which key is in the resulting map is undefined.

     Note: will not terminate for infinite-sized collections.

     returns

       a map containing all elements of this immutable parallel hash map.

     Definition Classes
       ParMap → ParIterableLike → GenTraversableOnce

129. #### def toParCollection[U >: (K, V), That](cbf: () ⇒ Combiner[U, That]): That

     Attributes
       protected
     Definition Classes
       ParIterableLike

130. #### def toParMap[K, V, That](cbf: () ⇒ Combiner[(K, V), That])(implicit ev: <:<[(K, V), (K, V)]): That

     Attributes
       protected
     Definition Classes
       ParIterableLike

131. #### def toSeq: ParSeq[(K, V)]

     Converts this immutable parallel hash map to a sequence.

     Converts this immutable parallel hash map to a sequence. As with `toIterable`, it's lazy in this default implementation, as this `TraversableOnce` may be lazy and unevaluated.

     Note: will not terminate for infinite-sized collections.

     returns

       a sequence containing all elements of this immutable parallel hash map.

     Definition Classes
       ParIterable → ParIterableLike → GenTraversableOnce

132. #### def toSet[U >: (K, V)]: ParSet[U]

     Converts this immutable parallel hash map to a set.

     Converts this immutable parallel hash map to a set.

     Note: will not terminate for infinite-sized collections.

     returns

       a set containing all elements of this immutable parallel hash map.

     Definition Classes
       ParIterableLike → GenTraversableOnce

133. #### def toStream: Stream[(K, V)]

     Converts this immutable parallel hash map to a stream.

     Converts this immutable parallel hash map to a stream.

     Note: will not terminate for infinite-sized collections.

     returns

       a stream containing all elements of this immutable parallel hash map.

     Definition Classes
       ParIterableLike → GenTraversableOnce

134. #### def toString(): String

     Creates a String representation of this object.

     Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

     returns

       a String representation of the object.

     Definition Classes
       ParIterableLike → AnyRef → Any

135. #### def toTraversable: GenTraversable[(K, V)]

     Converts this immutable parallel hash map to an unspecified Traversable.

     Converts this immutable parallel hash map to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     Note: will not terminate for infinite-sized collections.

     returns

       a Traversable containing all elements of this immutable parallel hash map.

     Definition Classes
       ParIterableLike → GenTraversableOnce

136. #### def transpose[B](implicit asTraversable: ((K, V)) ⇒ GenTraversableOnce[B]): ParIterable[ParIterable[B]]

     Transposes this immutable parallel hash map of traversable collections into a immutable parallel hash map of immutable parallel hash maps.

     Transposes this immutable parallel hash map of traversable collections into a immutable parallel hash map of immutable parallel hash maps.

     B

       the type of the elements of each traversable collection.

     asTraversable

       an implicit conversion which asserts that the element type of this immutable parallel hash map is a `Traversable`.

     returns

       a two-dimensional immutable parallel hash map of immutable parallel hash maps which has as nth row the nth column of this immutable parallel hash map.

     Definition Classes
       GenericTraversableTemplate
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

     Exceptions thrown
       `IllegalArgumentException`

       if all collections in this immutable parallel hash map are not of the same size.

137. #### def unzip[A1, A2](implicit asPair: ((K, V)) ⇒ (A1, A2)): (ParIterable[A1], ParIterable[A2])

     Converts this immutable parallel hash map of pairs into two collections of the first and second half of each pair.

     Converts this immutable parallel hash map of pairs into two collections of the first and second half of each pair.

     asPair

       an implicit conversion which asserts that the element type of this immutable parallel hash map is a pair.

     returns

       a pair immutable parallel hash maps, containing the first, respectively second half of each element pair of this immutable parallel hash map.

     Definition Classes
       GenericTraversableTemplate

138. #### def unzip3[A1, A2, A3](implicit asTriple: ((K, V)) ⇒ (A1, A2, A3)): (ParIterable[A1], ParIterable[A2], ParIterable[A3])

     Converts this immutable parallel hash map of triples into three collections of the first, second, and third element of each triple.

     Converts this immutable parallel hash map of triples into three collections of the first, second, and third element of each triple.

     asTriple

       an implicit conversion which asserts that the element type of this immutable parallel hash map is a triple.

     returns

       a triple immutable parallel hash maps, containing the first, second, respectively third member of each element triple of this immutable parallel hash map.

     Definition Classes
       GenericTraversableTemplate

139. #### def view: ParIterableView[(K, V), ParHashMap[K, V], HashMap[K, V]]

     Definition Classes
       ParIterableLike

140. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

141. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

142. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws()

143. #### def wrap[R](body: ⇒ R): NonDivisible[R]

     Attributes
       protected
     Definition Classes
       ParIterableLike

144. #### abstract def zip[B](that: GenIterable[B]): immutable.ParHashMap[((K, V), B)]

     [use case] Returns a immutable parallel hash map formed from this immutable parallel hash map and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a immutable parallel hash map formed from this immutable parallel hash map and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this immutable parallel hash map and `that`. The length of the returned collection is the minimum of the lengths of this immutable parallel hash map and `that`.

     Definition Classes
       GenIterableLike

145. #### def zip[U >: (K, V), S, That](that: GenIterable[S])(implicit bf: CanBuildFrom[ParHashMap[K, V], (U, S), That]): That

     Returns a immutable parallel hash map formed from this immutable parallel hash map and another iterable collection by combining corresponding elements in pairs.

     Returns a immutable parallel hash map formed from this immutable parallel hash map and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, B)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, B), That]`. is found.

     that

       The iterable providing the second half of each result pair

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and the new element type `(A1, B)`.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this immutable parallel hash map and `that`. The length of the returned collection is the minimum of the lengths of this immutable parallel hash map and `that`.

     Definition Classes
       ParIterableLike → GenIterableLike

146. #### abstract def zipAll[B](that: Iterable[B], thisElem: (K, V), thatElem: B): immutable.ParHashMap[((K, V), B)]

     [use case] Returns a immutable parallel hash map formed from this immutable parallel hash map and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a immutable parallel hash map formed from this immutable parallel hash map and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this immutable parallel hash map is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this immutable parallel hash map.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this immutable parallel hash map and `that`. The length of the returned collection is the maximum of the lengths of this immutable parallel hash map and `that`. If this immutable parallel hash map is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this immutable parallel hash map, `thatElem` values are used to pad the result.

     Definition Classes
       GenIterableLike

147. #### def zipAll[S, U >: (K, V), That](that: GenIterable[S], thisElem: U, thatElem: S)(implicit bf: CanBuildFrom[ParHashMap[K, V], (U, S), That]): That

     Returns a immutable parallel hash map formed from this immutable parallel hash map and another iterable collection by combining corresponding elements in pairs.

     Returns a immutable parallel hash map formed from this immutable parallel hash map and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     that

       the iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this immutable parallel hash map is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this immutable parallel hash map.

     returns

       a new collection of type `That` containing pairs consisting of corresponding elements of this immutable parallel hash map and `that`. The length of the returned collection is the maximum of the lengths of this immutable parallel hash map and `that`. If this immutable parallel hash map is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this immutable parallel hash map, `thatElem` values are used to pad the result.

     Definition Classes
       ParIterableLike → GenIterableLike

148. #### abstract def zipWithIndex: immutable.ParHashMap[((K, V), Int)]

     [use case] Zips this immutable parallel hash map with its indices.

     [use case]

     Zips this immutable parallel hash map with its indices.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this immutable parallel hash map paired with their index. Indices start at `0`.

     Definition Classes
       GenIterableLike

149. #### def zipWithIndex[U >: (K, V), That](implicit bf: CanBuildFrom[ParHashMap[K, V], (U, Int), That]): That

     Zips this immutable parallel hash map with its indices.

     Zips this immutable parallel hash map with its indices.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     That

       the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `(A1, Int)` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, (A1, Int), That]`. is found.

     returns

       A new collection of type `That` containing pairs consisting of all elements of this immutable parallel hash map paired with their index. Indices start at `0`.

     Definition Classes
       ParIterableLike → GenIterableLike

### Inherited from Serializable

### Inherited from ParMap[K, V]

### Inherited from ParIterable[(K, V)]

### Inherited from ParMap[K, V]

### Inherited from ParMapLike[K, V, ParHashMap[K, V], HashMap[K, V]]

### Inherited from ParIterable[(K, V)]

### Inherited from ParIterableLike[(K, V), ParHashMap[K, V], HashMap[K, V]]

### Inherited from Parallel

### Inherited from CustomParallelizable[(K, V), ParHashMap[K, V]]

### Inherited from GenericParMapTemplate[K, V, ParHashMap]

### Inherited from GenericParTemplate[(K, V), ParIterable]

### Inherited from HasNewCombiner[(K, V), ParHashMap[K, V]]

### Inherited from GenMap[K, V]

### Inherited from GenIterable[(K, V)]

### Inherited from GenTraversable[(K, V)]

### Inherited from GenericTraversableTemplate[(K, V), ParIterable]

### Inherited from HasNewBuilder[(K, V), ParIterable[(K, V)]]

### Inherited from GenMapLike[K, V, ParHashMap[K, V]]

### Inherited from Equals

### Inherited from GenIterableLike[(K, V), ParHashMap[K, V]]

### Inherited from GenTraversableLike[(K, V), ParHashMap[K, V]]

### Inherited from Parallelizable[(K, V), ParHashMap[K, V]]

### Inherited from GenTraversableOnce[(K, V)]

### Inherited from AnyRef

### Inherited from Any